diff --git a/src/main/java/net/minecraft/client/gui/hud/HealthBarComponent.java b/src/main/java/net/minecraft/client/gui/hud/component/HealthBarComponent.java
similarity index 87%
rename from src/main/java/net/minecraft/client/gui/hud/HealthBarComponent.java
rename to src/main/java/net/minecraft/client/gui/hud/component/HealthBarComponent.java
index 289690c39..0933e1d16 100644
--- a/src/main/java/net/minecraft/client/gui/hud/HealthBarComponent.java
+++ b/src/main/java/net/minecraft/client/gui/hud/component/HealthBarComponent.java
@@ -1,9 +1,9 @@
-package net.minecraft.client.gui.hud;
+package net.minecraft.client.gui.hud.component;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.Gui;
-import net.minecraft.client.gui.GuiIngame;
-import net.minecraft.client.render.texture.Texture;
+import net.minecraft.client.gui.hud.IngameHud;
+import net.minecraft.client.gui.hud.component.layout.Layout;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.item.IceCreamBucketItem;
 import net.minecraft.core.item.FoodItem;
@@ -26,7 +26,7 @@ public class HealthBarComponent
     }
 
     @Override
-    public void render(Minecraft mc, GuiIngame gui, int xSizeScreen, int ySizeScreen, float partialTick) {
+    public void render(Minecraft mc, IngameHud hud, int xSizeScreen, int ySizeScreen, float partialTick) {
         int x = this.getLayout().getComponentX(mc, this, xSizeScreen);
         int y = this.getLayout().getComponentY(mc, this, ySizeScreen);
 
@@ -41,7 +41,7 @@ public class HealthBarComponent
         }
         int health = mc.thePlayer.getHealth();
         int prevHealth = mc.thePlayer.prevHealth;
-        random.setSeed(gui.updateCounter * 0x4c627L);
+        random.setSeed(hud.updateCounter * 0x4c627L);
         boolean isHardcore = mc.thePlayer.getGamemode() == Gamemode.hardcore;
 
         for (int i = 0; i < 10; i++) {
@@ -57,29 +57,29 @@ public class HealthBarComponent
                 yHeart += random.nextInt(2);
             }
 
-            gui.drawGuiIcon(xHeart, yHeart, 9, 9, heartOffset == 0 ? TextureRegistry.getTexture("minecraft:gui/hud/heart/container") : TextureRegistry.getTexture("minecraft:gui/hud/heart/container_blinking"));
+            hud.drawGuiIcon(xHeart, yHeart, 9, 9, heartOffset == 0 ? TextureRegistry.getTexture("minecraft:gui/hud/heart/container") : TextureRegistry.getTexture("minecraft:gui/hud/heart/container_blinking"));
             if (heartsFlash)
             {
                 if (i * 2 + 1 < prevHealth)
                 {
                     // Half flash heart icon
-                    gui.drawGuiIcon(xHeart, yHeart, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/" + (isHardcore ? "hardcore_" : "") + "full_blinking"));
+                    hud.drawGuiIcon(xHeart, yHeart, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/" + (isHardcore ? "hardcore_" : "") + "full_blinking"));
                 }
                 if (i * 2 + 1 == prevHealth)
                 {
                     // Full flash heart icon
-                    gui.drawGuiIcon(xHeart, yHeart, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/" + (isHardcore ? "hardcore_" : "") + "half_blinking"));
+                    hud.drawGuiIcon(xHeart, yHeart, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/" + (isHardcore ? "hardcore_" : "") + "half_blinking"));
                 }
             }
             if (i * 2 + 1 < health)
             {
                 // Full heart icon
-                gui.drawGuiIcon(xHeart, yHeart, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/" + (isHardcore ? "hardcore_" : "") + "full"));
+                hud.drawGuiIcon(xHeart, yHeart, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/" + (isHardcore ? "hardcore_" : "") + "full"));
             }
             if (i * 2 + 1 == health)
             {
                 // Half heart icon
-                gui.drawGuiIcon(xHeart, yHeart, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/" + (isHardcore ? "hardcore_" : "") + "half"));
+                hud.drawGuiIcon(xHeart, yHeart, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/" + (isHardcore ? "hardcore_" : "") + "half"));
             }
             if (mc.thePlayer.inventory.getCurrentItem() != null && (mc.thePlayer.inventory.getCurrentItem().getItem() instanceof FoodItem || mc.thePlayer.inventory.getCurrentItem().getItem() instanceof IceCreamBucketItem) && mc.gameSettings.foodHealthRegenOverlay.value)
             {
@@ -97,15 +97,15 @@ public class HealthBarComponent
                 {
                     if (i * 2 + 1 == health)
                     {
-                        gui.drawGuiIcon(xHeart, yHeart, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/" + (isHardcore ? "hardcore_" : "") + "preview_half_right"));
+                        hud.drawGuiIcon(xHeart, yHeart, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/" + (isHardcore ? "hardcore_" : "") + "preview_half_right"));
                     }
                     else if (i * 2 + 1 < health + healing)
                     {
-                        gui.drawGuiIcon(xHeart, yHeart, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/" + (isHardcore ? "hardcore_" : "") + "preview_full"));
+                        hud.drawGuiIcon(xHeart, yHeart, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/" + (isHardcore ? "hardcore_" : "") + "preview_full"));
                     }
                     else if (i * 2 + 1 == health + healing)
                     {
-                        gui.drawGuiIcon(xHeart, yHeart, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/" + (isHardcore ? "hardcore_" : "") + "preview_half"));
+                        hud.drawGuiIcon(xHeart, yHeart, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/" + (isHardcore ? "hardcore_" : "") + "preview_half"));
                     }
                 }
             }
diff --git a/src/main/java/net/minecraft/client/gui/hud/HotbarComponent.java b/src/main/java/net/minecraft/client/gui/hud/component/HotbarComponent.java
similarity index 91%
rename from src/main/java/net/minecraft/client/gui/hud/HotbarComponent.java
rename to src/main/java/net/minecraft/client/gui/hud/component/HotbarComponent.java
index 352a69c55..6b5f56cea 100644
--- a/src/main/java/net/minecraft/client/gui/hud/HotbarComponent.java
+++ b/src/main/java/net/minecraft/client/gui/hud/component/HotbarComponent.java
@@ -1,8 +1,9 @@
-package net.minecraft.client.gui.hud;
+package net.minecraft.client.gui.hud.component;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.Gui;
-import net.minecraft.client.gui.GuiIngame;
+import net.minecraft.client.gui.hud.IngameHud;
+import net.minecraft.client.gui.hud.component.layout.Layout;
 import net.minecraft.client.render.Lighting;
 import net.minecraft.client.render.Scissor;
 import net.minecraft.client.render.item.model.ItemModel;
@@ -51,7 +52,7 @@ public class HotbarComponent
     }
 
     @Override
-    public void render(Minecraft mc, GuiIngame gui, int xSizeScreen, int ySizeScreen, float partialTick) {
+    public void render(Minecraft mc, IngameHud hud, int xSizeScreen, int ySizeScreen, float partialTick) {
         int x = this.getLayout().getComponentX(mc, this, xSizeScreen);
         int y = this.getLayout().getComponentY(mc, this, ySizeScreen);
 
@@ -61,14 +62,14 @@ public class HotbarComponent
         GL11.glColor4f(1.0f, 1.0f, 1.0f, 1.0f); // Reset color
 
         // Render hotbar
-        gui.drawGuiIcon(x + 5, y, 182, 22, TextureRegistry.getTexture("minecraft:gui/hud/hotbar"));
+        hud.drawGuiIcon(x + 5, y, 182, 22, TextureRegistry.getTexture("minecraft:gui/hud/hotbar"));
 
 
         // Render hotbar switcher and dots
         int selectedHotbar = ((inv.hotbarOffset + 27) % 36) / 9;
         IconCoordinate coordinate = TextureRegistry.getTexture("minecraft:gui/hud/hotbar_selector");
-        gui.drawIconTexture(x, y, x + 6, y + 22, 0, 0, 6, 22, coordinate);
-        gui.drawIconTexture(x, y + selectedHotbar * 5, x + 6, y + selectedHotbar * 5 + 5, 6, selectedHotbar * 5, 12, selectedHotbar * 5 + 5, coordinate);
+        hud.drawIconTexture(x, y, x + 6, y + 22, 0, 0, 6, 22, coordinate);
+        hud.drawIconTexture(x, y + selectedHotbar * 5, x + 6, y + selectedHotbar * 5 + 5, 6, selectedHotbar * 5, 12, selectedHotbar * 5 + 5, coordinate);
 
         // Setup items
         GL11.glEnable(GL11.GL_DEPTH_TEST);
@@ -124,9 +125,9 @@ public class HotbarComponent
         GL11.glColor4f(1.0f, 1.0f, 1.0f, 1.0f); // Reset color
 
         // Render selector
-        gui.drawGuiIcon((x + 4) + (inv.currentItem % 9) * 20, y - 1, 24, 24, TextureRegistry.getTexture("minecraft:gui/hud/hotbar_selection"));
+        hud.drawGuiIcon((x + 4) + (inv.currentItem % 9) * 20, y - 1, 24, 24, TextureRegistry.getTexture("minecraft:gui/hud/hotbar_selection"));
 
-        gui.guiHeldItemTooltip.updateAndRender(mc, x + 187/2, y - 20);
+        hud.heldItemTooltipElement.updateAndRender(mc, x + 187/2, y - 20);
     }
 
     @Override
@@ -183,17 +184,17 @@ public class HotbarComponent
             GL11.glScalef(1.0F / f2, (f2 + 1.0F) / 2.0F, 1.0F);
             GL11.glTranslatef(-(x + 8), -(y + 12), 0.0F);
         }
-        itemModel.renderItemIntoGui(Tessellator.instance, mc.fontRenderer, mc.renderEngine, itemstack, x, y, 1.0f);
+        itemModel.renderItemIntoGui(Tessellator.instance, mc.font, mc.textureManager, itemstack, x, y, 1.0f);
         if (animProgress > 0.0F)
         {
             GL11.glPopMatrix();
         }
-        itemModel.renderItemOverlayIntoGUI(Tessellator.instance, mc.fontRenderer, mc.renderEngine, itemstack, x, y, 1.0f);
+        itemModel.renderItemOverlayIntoGUI(Tessellator.instance, mc.font, mc.textureManager, itemstack, x, y, 1.0f);
     }
 
     private void renderItem(Minecraft mc, ItemStack itemStack, int x, int y) {
         ItemModel itemModel = ItemModelDispatcher.getInstance().getDispatch(itemStack.getItem());
-        itemModel.renderItemIntoGui(Tessellator.instance, mc.fontRenderer, mc.renderEngine, itemStack, x, y, 1.0f);
-        itemModel.renderItemOverlayIntoGUI(Tessellator.instance, mc.fontRenderer, mc.renderEngine, itemStack, x, y, 1.0f);
+        itemModel.renderItemIntoGui(Tessellator.instance, mc.font, mc.textureManager, itemStack, x, y, 1.0f);
+        itemModel.renderItemOverlayIntoGUI(Tessellator.instance, mc.font, mc.textureManager, itemStack, x, y, 1.0f);
     }
 }
diff --git a/src/main/java/net/minecraft/client/gui/hud/HudComponent.java b/src/main/java/net/minecraft/client/gui/hud/component/HudComponent.java
similarity index 81%
rename from src/main/java/net/minecraft/client/gui/hud/HudComponent.java
rename to src/main/java/net/minecraft/client/gui/hud/component/HudComponent.java
index 5451fc0ff..e461591ee 100644
--- a/src/main/java/net/minecraft/client/gui/hud/HudComponent.java
+++ b/src/main/java/net/minecraft/client/gui/hud/component/HudComponent.java
@@ -1,9 +1,12 @@
-package net.minecraft.client.gui.hud;
+package net.minecraft.client.gui.hud.component;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.Gui;
-import net.minecraft.client.gui.GuiHudDesigner;
-import net.minecraft.client.gui.GuiIngame;
+import net.minecraft.client.gui.HudDesignerScreen;
+import net.minecraft.client.gui.hud.IngameHud;
+import net.minecraft.client.gui.hud.component.layout.AbsoluteLayout;
+import net.minecraft.client.gui.hud.component.layout.Layout;
+import net.minecraft.client.gui.hud.component.layout.SnapLayout;
 
 public abstract class HudComponent {
     private final String key;
@@ -26,12 +29,12 @@ public abstract class HudComponent {
     }
 
     public int getXSize(Minecraft mc) {
-        if (!(mc.currentScreen instanceof GuiHudDesigner) && !isVisible(mc)) return 0;
+        if (!(mc.currentScreen instanceof HudDesignerScreen) && !isVisible(mc)) return 0;
         return xSize;
     }
 
     public int getYSize(Minecraft mc) {
-        if (!(mc.currentScreen instanceof GuiHudDesigner) && !isVisible(mc)) return 0;
+        if (!(mc.currentScreen instanceof HudDesignerScreen) && !isVisible(mc)) return 0;
         return ySize;
     }
 
@@ -47,7 +50,7 @@ public abstract class HudComponent {
         return layout;
     }
 
-    public abstract void render(Minecraft mc, GuiIngame gui, int xSizeScreen, int ySizeScreen, float partialTick);
+    public abstract void render(Minecraft mc, IngameHud hud, int xSizeScreen, int ySizeScreen, float partialTick);
 
     public abstract void renderPreview(Minecraft mc, Gui gui, Layout layout, int xSizeScreen, int ySizeScreen);
 
diff --git a/src/main/java/net/minecraft/client/gui/hud/HudComponents.java b/src/main/java/net/minecraft/client/gui/hud/component/HudComponents.java
similarity index 83%
rename from src/main/java/net/minecraft/client/gui/hud/HudComponents.java
rename to src/main/java/net/minecraft/client/gui/hud/component/HudComponents.java
index 32bbb9f9b..71ec8c3c2 100644
--- a/src/main/java/net/minecraft/client/gui/hud/HudComponents.java
+++ b/src/main/java/net/minecraft/client/gui/hud/component/HudComponents.java
@@ -1,19 +1,26 @@
-package net.minecraft.client.gui.hud;
+package net.minecraft.client.gui.hud.component;
+
+import com.mojang.logging.LogUtils;
+import net.minecraft.client.gui.hud.component.layout.AbsoluteLayout;
+import net.minecraft.client.gui.hud.component.layout.SnapLayout;
+import org.slf4j.Logger;
 
 import java.util.ArrayList;
 import java.util.List;
 
 public class HudComponents {
-    public static final HudComponents INSTANCE = new HudComponents();
+    private static final Logger LOGGER = LogUtils.getLogger();
+
     public static String DEFAULT_LAYOUT = null;
+    public static final HudComponents INSTANCE = new HudComponents();
 
     public static HudComponent register(HudComponent component) {
         INSTANCE.components.add(component);
         return component;
     }
-
     private final List<HudComponent> components = new ArrayList<>();
 
+
     private HudComponents() { }
 
     public List<HudComponent> getComponents() {
@@ -43,7 +50,7 @@ public class HudComponents {
             String key = part.substring(0, part.indexOf('{'));
             HudComponent component = getComponent(key);
             if (component == null) {
-                System.out.println("Unknown component: " + key);
+                LOGGER.warn("Unknown component: {}", key);
                 continue;
             }
             String componentSettings = part.substring(part.indexOf('{') + 1, part.lastIndexOf('}'));
@@ -58,4 +65,5 @@ public class HudComponents {
     public static final HudComponent OXYGEN_BAR = register(new OxygenBarComponent("oxygen_bar", new SnapLayout(HEALTH_BAR, ComponentAnchor.TOP_LEFT, ComponentAnchor.BOTTOM_LEFT)));
     public static final HudComponent FIRE_BAR = register(new FireBarComponent("fire_bar", new SnapLayout(OXYGEN_BAR, ComponentAnchor.TOP_LEFT, ComponentAnchor.BOTTOM_LEFT)));
     public static final HudComponent ROTATION_LOCK = register(new RotationLockComponent("rotation_lock", new SnapLayout(CROSSHAIR, ComponentAnchor.CENTER_RIGHT, ComponentAnchor.CENTER_LEFT)));
+    public static final HudComponent SUBTITLES = register(new SubtitleComponent("subtitles_box", 100, 50, new AbsoluteLayout(1.0f, 0.75f, ComponentAnchor.BOTTOM_RIGHT)));
 }
diff --git a/src/main/java/net/minecraft/client/gui/hud/MovableHudComponent.java b/src/main/java/net/minecraft/client/gui/hud/component/MovableHudComponent.java
similarity index 71%
rename from src/main/java/net/minecraft/client/gui/hud/MovableHudComponent.java
rename to src/main/java/net/minecraft/client/gui/hud/component/MovableHudComponent.java
index 35e6d93ad..f22ce9bfa 100644
--- a/src/main/java/net/minecraft/client/gui/hud/MovableHudComponent.java
+++ b/src/main/java/net/minecraft/client/gui/hud/component/MovableHudComponent.java
@@ -1,4 +1,6 @@
-package net.minecraft.client.gui.hud;
+package net.minecraft.client.gui.hud.component;
+
+import net.minecraft.client.gui.hud.component.layout.Layout;
 
 public abstract class MovableHudComponent
     extends HudComponent {
diff --git a/src/main/java/net/minecraft/client/gui/hud/OxygenBarComponent.java b/src/main/java/net/minecraft/client/gui/hud/component/OxygenBarComponent.java
similarity index 87%
rename from src/main/java/net/minecraft/client/gui/hud/OxygenBarComponent.java
rename to src/main/java/net/minecraft/client/gui/hud/component/OxygenBarComponent.java
index 1028528ac..cdd55a32f 100644
--- a/src/main/java/net/minecraft/client/gui/hud/OxygenBarComponent.java
+++ b/src/main/java/net/minecraft/client/gui/hud/component/OxygenBarComponent.java
@@ -1,8 +1,9 @@
-package net.minecraft.client.gui.hud;
+package net.minecraft.client.gui.hud.component;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.Gui;
-import net.minecraft.client.gui.GuiIngame;
+import net.minecraft.client.gui.hud.IngameHud;
+import net.minecraft.client.gui.hud.component.layout.Layout;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.material.Material;
@@ -24,7 +25,7 @@ public class OxygenBarComponent
     }
 
     @Override
-    public void render(Minecraft mc, GuiIngame gui, int xSizeScreen, int ySizeScreen, float partialTick) {
+    public void render(Minecraft mc, IngameHud hud, int xSizeScreen, int ySizeScreen, float partialTick) {
         int x = this.getLayout().getComponentX(mc, this, xSizeScreen);
         int y = this.getLayout().getComponentY(mc, this, ySizeScreen);
 
@@ -38,11 +39,11 @@ public class OxygenBarComponent
         {
             if (i < numBubbles)
             {
-                gui.drawGuiIcon(x + i * 8, y, 9, 9, air);
+                hud.drawGuiIcon(x + i * 8, y, 9, 9, air);
             }
             else
             {
-                gui.drawGuiIcon(x + i * 8, y, 9, 9, air_pop);
+                hud.drawGuiIcon(x + i * 8, y, 9, 9, air_pop);
             }
         }
     }
diff --git a/src/main/java/net/minecraft/client/gui/hud/RotationLockComponent.java b/src/main/java/net/minecraft/client/gui/hud/component/RotationLockComponent.java
similarity index 90%
rename from src/main/java/net/minecraft/client/gui/hud/RotationLockComponent.java
rename to src/main/java/net/minecraft/client/gui/hud/component/RotationLockComponent.java
index 02cc03dd5..e82b1dcbf 100644
--- a/src/main/java/net/minecraft/client/gui/hud/RotationLockComponent.java
+++ b/src/main/java/net/minecraft/client/gui/hud/component/RotationLockComponent.java
@@ -1,8 +1,9 @@
-package net.minecraft.client.gui.hud;
+package net.minecraft.client.gui.hud.component;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.Gui;
-import net.minecraft.client.gui.GuiIngame;
+import net.minecraft.client.gui.hud.IngameHud;
+import net.minecraft.client.gui.hud.component.layout.Layout;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.util.helper.Direction;
@@ -20,7 +21,7 @@ public class RotationLockComponent
     }
 
     @Override
-    public void render(Minecraft mc, GuiIngame gui, int xSizeScreen, int ySizeScreen, float partialTick) {
+    public void render(Minecraft mc, IngameHud hud, int xSizeScreen, int ySizeScreen, float partialTick) {
         // Setup rendering
         GL11.glColor4f(1.0f, 1.0f, 1.0f, 1.0f); // Reset color
         GL11.glDisable(GL11.GL_BLEND);
@@ -78,10 +79,10 @@ public class RotationLockComponent
         }
 
         String[] dirTextures = new String[]{"down", "up", "back", "front", "left", "right"};
-        gui.drawGuiIcon(x, y, 16, 16, TextureRegistry.getTexture("minecraft:gui/hud/rotation/" + prefix + "_" + dirTextures[dir.getId()]));
+        hud.drawGuiIcon(x, y, 16, 16, TextureRegistry.getTexture("minecraft:gui/hud/rotation/" + prefix + "_" + dirTextures[dir.getId()]));
         dir = Direction.getVerticalDirection(player);
         dirTextures = new String[]{"downer", "upper", "back", "front", "left", "right"};
-        gui.drawGuiIcon(x + 16, y + 4, 8, 8, TextureRegistry.getTexture("minecraft:gui/hud/rotation/" + prefix + "_" + dirTextures[dir.getId()]));
+        hud.drawGuiIcon(x + 16, y + 4, 8, 8, TextureRegistry.getTexture("minecraft:gui/hud/rotation/" + prefix + "_" + dirTextures[dir.getId()]));
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/client/gui/hud/component/SubtitleComponent.java b/src/main/java/net/minecraft/client/gui/hud/component/SubtitleComponent.java
new file mode 100644
index 000000000..aa427a9c0
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/hud/component/SubtitleComponent.java
@@ -0,0 +1,116 @@
+package net.minecraft.client.gui.hud.component;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.gui.Gui;
+import net.minecraft.client.gui.hud.IngameHud;
+import net.minecraft.client.gui.hud.component.layout.Layout;
+import net.minecraft.client.gui.subtitles.SubtitleTracker;
+import net.minecraft.client.sound.SoundRepository;
+import org.lwjgl.opengl.GL11;
+
+import java.util.ArrayList;
+import java.util.List;
+
+import static org.lwjgl.opengl.GL11.GL_ALPHA_TEST;
+import static org.lwjgl.opengl.GL11.GL_BLEND;
+import static org.lwjgl.opengl.GL11.GL_ONE_MINUS_SRC_ALPHA;
+import static org.lwjgl.opengl.GL11.GL_SRC_ALPHA;
+
+public class SubtitleComponent extends MovableHudComponent{
+    public SubtitleComponent(String key, int xSize, int ySize, Layout layout) {
+        super(key, xSize, ySize, layout);
+    }
+
+    @Override
+    public boolean isVisible(Minecraft mc) {
+        return mc.gameSettings.subtitles.value;
+    }
+
+    @Override
+    public void render(Minecraft mc, IngameHud hud, int xSizeScreen, int ySizeScreen, float partialTick) {
+        drawChat(mc, hud, new ArrayList<>(mc.subtitleTracker.entryMap.values()), xSizeScreen, ySizeScreen, partialTick);
+    }
+
+    @Override
+    public void renderPreview(Minecraft mc, Gui gui, Layout layout, int xSizeScreen, int ySizeScreen) {
+        List<SubtitleTracker.SubtitleEntry> example = new ArrayList<>();
+        example.add(new SubtitleTracker.SubtitleEntry(SoundRepository.SOUNDS.getSoundEvent("mob.wolf.whine"), 0, 0, 0));
+        example.add(new SubtitleTracker.SubtitleEntry(SoundRepository.SOUNDS.getSoundEvent("random.drr"), 0, 0, 0));
+        example.add(new SubtitleTracker.SubtitleEntry(SoundRepository.SOUNDS.getSoundEvent("random.bow"), 0, 0, 0));
+        drawChat(mc, gui, example, xSizeScreen, ySizeScreen, 0);
+    }
+
+    public void drawChat(Minecraft mc, Gui gui, List<SubtitleTracker.SubtitleEntry> subtitleEntries, int xSizeScreen, int ySizeScreen, float partialTick)
+    {
+        int x = this.getLayout().getComponentX(mc, this, xSizeScreen);
+        int y = this.getLayout().getComponentY(mc, this, ySizeScreen);
+        int width = getXSize(mc);
+        int height = getYSize(mc);
+        int xRight = x + width;
+        int yBottom = y + height;
+        int messagesToShow = height/10;
+        boolean ignoreFadeout = false;
+
+        int maxMessageWidth = 0;
+        for (int i = 0; i < subtitleEntries.size() && i < messagesToShow; i++)
+        {
+            SubtitleTracker.SubtitleEntry entry = subtitleEntries.get(i);
+            if (entry.soundEvent == null) {
+                continue;
+            }
+            int msgWidth = mc.font.getStringWidth(entry.soundEvent.getSubtitleTranslated());
+            if (msgWidth > maxMessageWidth) {
+                maxMessageWidth = msgWidth;
+            }
+        }
+        maxMessageWidth += mc.font.getStringWidth("<") + mc.font.getStringWidth(">");
+
+        GL11.glEnable(GL_BLEND);
+        GL11.glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
+        GL11.glDisable(GL_ALPHA_TEST);
+        for (int i = 0; i < subtitleEntries.size() && i < messagesToShow; i++)
+        {
+            SubtitleTracker.SubtitleEntry entry = subtitleEntries.get(i);
+            if (entry.soundEvent == null) {
+                System.err.println("Null sound event in entry map!");
+                continue;
+            }
+            double fadeAmount = entry.getFadeout();
+            fadeAmount = 1.0D - fadeAmount;
+            fadeAmount *= 10D;
+            if (fadeAmount < 0.0D)
+            {
+                fadeAmount = 0.0D;
+            }
+            if (fadeAmount > 1.0D)
+            {
+                fadeAmount = 1.0D;
+            }
+            fadeAmount *= fadeAmount;
+            int alpha = (int) (255D * fadeAmount);
+            if (ignoreFadeout)
+            {
+                alpha = 255;
+            }
+            if (alpha > 0)
+            {
+                byte xPad = 3;
+                int y2 = -i * 9 - 8;
+                String s1 = entry.soundEvent.getSubtitleTranslated();
+                gui.drawRect(xRight - maxMessageWidth - xPad * 2, yBottom + y2 - 1, xRight, yBottom + y2 + 8, alpha / 2 << 24);
+                GL11.glEnable(GL_BLEND);
+                mc.font.drawCenteredString(s1, xRight - (maxMessageWidth) / 2 - xPad, yBottom + y2, 0xFFFFFF + (alpha << 24));
+                if (mc.thePlayer != null) {
+                    double sin = Math.sin(entry.getRelativeAngle(mc.thePlayer) + Math.PI/2);
+                    if (sin > 0.7) {
+                        mc.font.drawString("<", xRight - maxMessageWidth - xPad, yBottom + y2, 0xFFFFFF + (alpha << 24));
+                    } else if (sin < -0.7) {
+                        mc.font.drawString(">", xRight - mc.font.getStringWidth(">") - xPad/2, yBottom + y2, 0xFFFFFF + (alpha << 24));
+                    }
+                }
+            }
+        }
+        GL11.glEnable(GL_ALPHA_TEST);
+        GL11.glDisable(GL_BLEND);
+    }
+}
diff --git a/src/main/java/net/minecraft/client/gui/hud/AbsoluteLayout.java b/src/main/java/net/minecraft/client/gui/hud/component/layout/AbsoluteLayout.java
similarity index 91%
rename from src/main/java/net/minecraft/client/gui/hud/AbsoluteLayout.java
rename to src/main/java/net/minecraft/client/gui/hud/component/layout/AbsoluteLayout.java
index bb50c372f..21c1a17b0 100644
--- a/src/main/java/net/minecraft/client/gui/hud/AbsoluteLayout.java
+++ b/src/main/java/net/minecraft/client/gui/hud/component/layout/AbsoluteLayout.java
@@ -1,6 +1,8 @@
-package net.minecraft.client.gui.hud;
+package net.minecraft.client.gui.hud.component.layout;
 
 import net.minecraft.client.Minecraft;
+import net.minecraft.client.gui.hud.component.ComponentAnchor;
+import net.minecraft.client.gui.hud.component.HudComponent;
 
 public class AbsoluteLayout
     extends Layout {
diff --git a/src/main/java/net/minecraft/client/gui/hud/Layout.java b/src/main/java/net/minecraft/client/gui/hud/component/layout/Layout.java
similarity index 77%
rename from src/main/java/net/minecraft/client/gui/hud/Layout.java
rename to src/main/java/net/minecraft/client/gui/hud/component/layout/Layout.java
index 57c5db591..d040060ee 100644
--- a/src/main/java/net/minecraft/client/gui/hud/Layout.java
+++ b/src/main/java/net/minecraft/client/gui/hud/component/layout/Layout.java
@@ -1,6 +1,7 @@
-package net.minecraft.client.gui.hud;
+package net.minecraft.client.gui.hud.component.layout;
 
 import net.minecraft.client.Minecraft;
+import net.minecraft.client.gui.hud.component.HudComponent;
 
 public abstract class Layout {
     public abstract int getComponentX(Minecraft mc, HudComponent component, int xSizeScreen);
diff --git a/src/main/java/net/minecraft/client/gui/hud/SnapLayout.java b/src/main/java/net/minecraft/client/gui/hud/component/layout/SnapLayout.java
similarity index 91%
rename from src/main/java/net/minecraft/client/gui/hud/SnapLayout.java
rename to src/main/java/net/minecraft/client/gui/hud/component/layout/SnapLayout.java
index dae93b705..f86a493a2 100644
--- a/src/main/java/net/minecraft/client/gui/hud/SnapLayout.java
+++ b/src/main/java/net/minecraft/client/gui/hud/component/layout/SnapLayout.java
@@ -1,6 +1,9 @@
-package net.minecraft.client.gui.hud;
+package net.minecraft.client.gui.hud.component.layout;
 
 import net.minecraft.client.Minecraft;
+import net.minecraft.client.gui.hud.component.ComponentAnchor;
+import net.minecraft.client.gui.hud.component.HudComponent;
+import net.minecraft.client.gui.hud.component.HudComponents;
 
 public class SnapLayout
     extends Layout {
